////////////////////////////////////////////////////////////////////////////////
//     BPD_Dup.dll  DirectShow 
//  Behold TV
////////////////////////////////////////////////////////////////////////////////

#include "resource.h"
#include <stdio.h>
#include <windows.h>
#include <commctrl.h>
#include "..\..\API\Common.h"


#define BH_PLUGIN_EXP	__declspec(dllexport)

//     
#define szPluginName	"Duplication fields deinterlace"

//  ,  		
#define szPluginDesc	"  "


// ****************   () **************************


typedef struct 
{
	ULONG	MyPar1;
	ULONG	MyPar2;
	ULONG	MyPar3;
	BOOL	MyPar4;

} TSettings;


HWND			g_hDlg = NULL;
HINSTANCE		g_hInst = NULL;
TCHAR			g_szIniFile[MAX_PATH] = "";
TSettings		g_MySet = {645, 90, 60, TRUE};	

int				g_nFrameWidth;
int				g_nFrameHeight;
int				g_nBitPerPixel;
ePixFmt			g_PixFmt;
ULONG			g_ulTypeCPU;



//       ,    
void GetIniFileName()
{
	char	szPathFull[MAX_PATH];
	char	szPathIni[MAX_PATH];
	char	szNameDll[MAX_PATH];
	char	szNameIni[MAX_PATH];
	char	*pszFile;

	if (GetModuleFileName(g_hInst, szPathFull, sizeof(szPathFull)))
	{
		if (GetFullPathName(szPathFull, sizeof(szPathIni), szPathIni, &pszFile))
		{
			strcpy(szNameDll, pszFile);

			int	nLen = strlen(szNameDll) - 4;

			strncpy(szNameIni, szNameDll, nLen);
			szNameIni[nLen] = 0;

			strcat(szNameIni, ".ini");
			strcpy(pszFile, szNameIni);

			strcpy(g_szIniFile, szPathIni);
			pszFile = NULL; 
		}
	}
}

//   
void LoadPluginSettings()
{
	if (g_szIniFile[0] == 0)
		GetIniFileName();

	//       Preview  Capture ( )
	if (g_szIniFile[0] != 0)
	{
		g_MySet.MyPar1 = (ULONG) GetPrivateProfileInt("Common", "MyPar1", 645, g_szIniFile);
		g_MySet.MyPar2 = (ULONG) GetPrivateProfileInt("Common", "MyPar2", 90, g_szIniFile);
		g_MySet.MyPar3 = (ULONG) GetPrivateProfileInt("Common", "MyPar3", 60, g_szIniFile);
		g_MySet.MyPar4 = (BOOL) GetPrivateProfileInt("Common", "MyPar4", 1, g_szIniFile);
	}

}

//   
void SavePluginSettings()
{
	if (g_szIniFile[0] == 0)
		GetIniFileName();

	if (g_szIniFile[0] != 0)
	{
		TCHAR szPar[32];

		sprintf(szPar, "%u", g_MySet.MyPar1); 
		WritePrivateProfileString("Common", "MyPar1", szPar, g_szIniFile); 

		sprintf(szPar, "%u", g_MySet.MyPar2); 
		WritePrivateProfileString("Common", "MyPar2", szPar, g_szIniFile); 

		sprintf(szPar, "%u", g_MySet.MyPar3); 
		WritePrivateProfileString("Common", "MyPar3", szPar, g_szIniFile); 

		sprintf(szPar, "%u", g_MySet.MyPar4); 
		WritePrivateProfileString("Common", "MyPar4", szPar, g_szIniFile); 

	}

}


void AppendDialogParams(HWND hwDlg)
{
	SetDlgItemInt(hwDlg, IDC_PAR1, g_MySet.MyPar1, FALSE);
	SetDlgItemInt(hwDlg, IDC_PAR2, g_MySet.MyPar2, FALSE);
	SetDlgItemInt(hwDlg, IDC_PAR3, g_MySet.MyPar3, FALSE);

	CheckDlgButton(hwDlg, IDC_PAR4, g_MySet.MyPar4);
}

// Callback     
LRESULT CALLBACK DialogProc(HWND hDlgW, UINT message, WPARAM wParam, LPARAM lParam)
{
    switch (message)
    {
		case WM_INITDIALOG:			//  
			{
				SendMessage(GetDlgItem( hDlgW, IDC_PAR1_SPIN ), UDM_SETRANGE, 0, MAKELPARAM(999, 0));
				SendMessage(GetDlgItem( hDlgW, IDC_PAR2_SPIN ), UDM_SETRANGE, 0, MAKELPARAM(999, 0));
				SendMessage(GetDlgItem( hDlgW, IDC_PAR3_SPIN ), UDM_SETRANGE, 0, MAKELPARAM(999, 0));

				SetWindowText(hDlgW, szPluginName);
				AppendDialogParams(hDlgW);

				return TRUE;
			}
			break;
		case WM_DESTROY:			//  
			{
				g_hDlg = NULL;

				SavePluginSettings();

				return TRUE;
			}
			break;
		case WM_COMMAND:			//     

			switch LOWORD(wParam)
			{
				case ID_EXIT:		//  ""
					{
						DestroyWindow(hDlgW);
						return TRUE;
					}
					break;

				case ID_APPLY:      //  ""                
					{
						g_MySet.MyPar1 = GetDlgItemInt(hDlgW, IDC_PAR1, NULL, FALSE);
						g_MySet.MyPar2 = GetDlgItemInt(hDlgW, IDC_PAR2, NULL, FALSE);
						g_MySet.MyPar3 = GetDlgItemInt(hDlgW, IDC_PAR3, NULL, FALSE);
			            g_MySet.MyPar4 = (IsDlgButtonChecked(hDlgW, IDC_PAR4) == BST_CHECKED);

						return TRUE;
					}
					break;

				case ID_DEFAULT:    //  " "                
					{
						g_MySet.MyPar1 = 645;
						g_MySet.MyPar2 = 90;
						g_MySet.MyPar3 = 60;
						g_MySet.MyPar4 = TRUE;

						AppendDialogParams(hDlgW);

						return TRUE;
					}
					break;  
        
				default:
					break;

			}
			break;

		default:
			break;
    }
    return (FALSE);
}


// ******************   (  API) *********************

////////////////////////////////////////////////////////////////////////////////
// *   *
////////////////////////////////////////////////////////////////////////////////
void __cdecl PD_Init(void)
{
	//     

	LoadPluginSettings();  //    
}


////////////////////////////////////////////////////////////////////////////////
// *  StartStreaming *
////////////////////////////////////////////////////////////////////////////////
BOOL __cdecl PD_StartStreaming(PARAM_STR *pDiPar)
{
	//     
	//   ,  CPU ( )
	// ( ,       ..)

	g_nFrameWidth	= pDiPar->FrameWidth;
	g_nFrameHeight	= pDiPar->FrameHeight;
	g_nBitPerPixel	= pDiPar->BitPerPixel;
	g_PixFmt		= pDiPar->PixFmt;
	g_ulTypeCPU		= pDiPar->TypeCPU;


	//..........................................

	return TRUE;
}


////////////////////////////////////////////////////////////////////////////////
// *   *
////////////////////////////////////////////////////////////////////////////////

BOOL __cdecl PD_Double(DINT_STR *pDi)
{

	// .        
	//    

	BYTE* pSrcBuffer;
	BYTE* pDstBuffer;
	int i;

	pDstBuffer = pDi->DstBuffer;

	if (pDi->IsOdd)						// ,    
	{
		pSrcBuffer = *pDi->SrcOdd[0];	//         

		if (pSrcBuffer == NULL)			//    
			return FALSE;


		pDi->pMcpy(pDstBuffer, pSrcBuffer, pDi->SrcLength);		//   
		pDstBuffer += pDi->DstPitch;							//  ,    
																//   
		for (i = 0; i < pDi->FieldHeight - 1; i++)
		{
			//        

			pDi->pMcpy(pDstBuffer, pSrcBuffer, pDi->SrcLength);	
			pDstBuffer += pDi->DstPitch;						//      				

			pDi->pMcpy(pDstBuffer, pSrcBuffer, pDi->SrcLength);
			pSrcBuffer += pDi->SrcPitch;						//        
			pDstBuffer += pDi->DstPitch;						//      
		}

		pDi->pMcpy(pDstBuffer, pSrcBuffer, pDi->SrcLength);

	}
	else
	{
		pSrcBuffer =  *pDi->SrcEven[0];							//         

		if (pSrcBuffer == NULL)									//    
			return FALSE;

		for (i = 0; i < pDi->FieldHeight; i++)
		{
			//        

			pDi->pMcpy(pDstBuffer, pSrcBuffer, pDi->SrcLength);	
			pDstBuffer += pDi->DstPitch;						//      			

			pDi->pMcpy(pDstBuffer, pSrcBuffer, pDi->SrcLength);
			pSrcBuffer += pDi->SrcPitch;						//        
			pDstBuffer += pDi->DstPitch;						//      
		}


	}


	// .
	//       ,  
	//      ,   IsOdd   
	// 

	return TRUE;

}

////////////////////////////////////////////////////////////////////////////////
// *  StopStreaming *
////////////////////////////////////////////////////////////////////////////////
void __cdecl PD_StopStreaming()
{
	//     
	// (      ..)
}


////////////////////////////////////////////////////////////////////////////////
// *     *
////////////////////////////////////////////////////////////////////////////////
void __cdecl PD_ShowDialog(DLG_STR *pDlgPar)
{

	if(!g_hDlg)
	{
		if (g_szIniFile[0] == 0)
			LoadPluginSettings();

		g_hDlg = CreateDialogParam(g_hInst, MAKEINTRESOURCE (IDD_MYDIALOG), pDlgPar->hwndParent, (DLGPROC) DialogProc, (LPARAM) pDlgPar->IsCapture);
		if (g_hDlg)
		{
			//      

			RECT pRect, lRect;

			GetWindowRect(pDlgPar->hwndParent, &pRect);
			GetWindowRect(g_hDlg, &lRect);

			int lft, top;

			lft = pRect.left + (pRect.right / 2 - lRect.right / 2);		
			top = pRect.top + (pRect.bottom / 2 - lRect.bottom / 2);

			SetWindowPos(g_hDlg, HWND_TOP, lft, top, 0, 0, SWP_NOACTIVATE | SWP_NOSIZE);
			ShowWindow(g_hDlg, SW_SHOW);
		}
	}

}


////////////////////////////////////////////////////////////////////////////////
// *   *
////////////////////////////////////////////////////////////////////////////////
void __cdecl PD_Uninit()
{
	//     

	SavePluginSettings();		//    

	if(g_hDlg)
	{
		DestroyWindow(g_hDlg);  //  
		g_hDlg = NULL;
	}

}

////////////////////////////////////////////////////////////////////////////////
// *     *
////////////////////////////////////////////////////////////////////////////////
DINT_PLUGIN DoublePlugin =
{
	szPluginName,				//  
	szPluginDesc,				//  
	PD_Init,					//     (  NULL)
	PD_StartStreaming,			//    StartStreaming (  NULL)
	PD_Double,					//     ()
	PD_StopStreaming,			//    StopStreaming (  NULL)
	PD_ShowDialog,				//       (  NULL)
	PD_Uninit					//     (  NULL)
};


// ********************* Exports ***********************************************

extern "C" {

BH_PLUGIN_EXP ULONG BeholdTV_Plugin_Version()
{
	return DSPLUGINVER;		//    
}


BH_PLUGIN_EXP DINT_PLUGIN* BeholdTV_Plugin_DI()
{
	return &DoublePlugin;	//     
}

}

// ********************* DllMain ************************************************

BOOL APIENTRY DllMain( HINSTANCE hModule, DWORD ul_reason_for_call, LPVOID lpReserved)
{
	switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
			g_hInst = hModule;
			break;
		case DLL_PROCESS_DETACH:
			break;
	}
	return TRUE;
}