////////////////////////////////////////////////////////////////////////////////
//      DirectShow  Behold TV.
//    - "BPP_Inverse.dll"
////////////////////////////////////////////////////////////////////////////////

#include "resource.h"
#include <stdio.h>
#include <windows.h>
#include <commctrl.h>
#include "..\..\API\Common.h"


#define BH_PLUGIN_EXP	__declspec(dllexport)

//     
#define szPluginName	" "

//  ,  		
#define szPluginDesc	"    (  MMX)"


// ****************   () **************************

//      
#define DefaultPar1		210
#define DefaultPar2		300
#define DefaultPar3		8
#define DefaultPar4		TRUE


typedef struct 
{
	ULONG	MyPar1;
	ULONG	MyPar2;
	ULONG	MyPar3;
	BOOL	MyPar4;

} TSettings;


HWND			g_hDlg = NULL;
HINSTANCE		g_hInst = NULL;
TCHAR			g_szIniFile[MAX_PATH] = "";
TSettings		g_MyPreviewSet = {DefaultPar1, DefaultPar2, DefaultPar3, DefaultPar4};	
TSettings		g_MyCaptureSet = {DefaultPar1, DefaultPar2, DefaultPar3, DefaultPar4};	


ULONG			g_TypeCPU;
BOOL			g_IsCaptureMode;
ePixFmt			g_PixFmt;

BY_ORD_FUNC		*g_PtrByOrd;
BY_IDX_FUNC		*g_PtrByIdx;



//       ,    
void GetIniFileName()
{
	char	szPathFull[MAX_PATH];
	char	szPathIni[MAX_PATH];
	char	szNameDll[MAX_PATH];
	char	szNameIni[MAX_PATH];
	char	*pszFile;

	if (GetModuleFileName(g_hInst, szPathFull, sizeof(szPathFull)))
	{
		if (GetFullPathName(szPathFull, sizeof(szPathIni), szPathIni, &pszFile))
		{
			strcpy(szNameDll, pszFile);

			int	nLen = strlen(szNameDll) - 4;

			strncpy(szNameIni, szNameDll, nLen);
			szNameIni[nLen] = 0;

			strcat(szNameIni, ".ini");
			strcpy(pszFile, szNameIni);

			strcpy(g_szIniFile, szPathIni);
			pszFile = NULL; 
		}
	}
}


//   
void LoadPluginSettings()
{
	if (g_szIniFile[0] == 0)
		GetIniFileName();

	//       Preview  Capture ( )
	if (g_szIniFile[0] != 0)
	{
		g_MyPreviewSet.MyPar1 = (ULONG) GetPrivateProfileInt("Preview", "MyPar1", DefaultPar1, g_szIniFile);
		g_MyPreviewSet.MyPar2 = (ULONG) GetPrivateProfileInt("Preview", "MyPar2", DefaultPar2, g_szIniFile);
		g_MyPreviewSet.MyPar3 = (ULONG) GetPrivateProfileInt("Preview", "MyPar3", DefaultPar3, g_szIniFile);
		g_MyPreviewSet.MyPar4 = (BOOL)  GetPrivateProfileInt("Preview", "MyPar4", DefaultPar4, g_szIniFile);

		g_MyCaptureSet.MyPar1 = (ULONG) GetPrivateProfileInt("Capture", "MyPar1", DefaultPar1, g_szIniFile);
		g_MyCaptureSet.MyPar2 = (ULONG) GetPrivateProfileInt("Capture", "MyPar2", DefaultPar2, g_szIniFile);
		g_MyCaptureSet.MyPar3 = (ULONG) GetPrivateProfileInt("Capture", "MyPar3", DefaultPar3, g_szIniFile);
		g_MyCaptureSet.MyPar4 = (BOOL)  GetPrivateProfileInt("Capture", "MyPar4", DefaultPar4, g_szIniFile);

	}

}

//   
void SavePluginSettings()
{
	if (g_szIniFile[0] == 0)
		GetIniFileName();

	if (g_szIniFile[0] != 0)
	{
		TCHAR szPar[32];

		sprintf(szPar, "%u", g_MyPreviewSet.MyPar1); 
		WritePrivateProfileString("Preview", "MyPar1", szPar, g_szIniFile); 

		sprintf(szPar, "%u", g_MyPreviewSet.MyPar2); 
		WritePrivateProfileString("Preview", "MyPar2", szPar, g_szIniFile); 

		sprintf(szPar, "%u", g_MyPreviewSet.MyPar3); 
		WritePrivateProfileString("Preview", "MyPar3", szPar, g_szIniFile); 

		sprintf(szPar, "%u", g_MyPreviewSet.MyPar4); 
		WritePrivateProfileString("Preview", "MyPar4", szPar, g_szIniFile); 


		sprintf(szPar, "%u", g_MyCaptureSet.MyPar1); 
		WritePrivateProfileString("Capture", "MyPar1", szPar, g_szIniFile); 

		sprintf(szPar, "%u", g_MyCaptureSet.MyPar2); 
		WritePrivateProfileString("Capture", "MyPar2", szPar, g_szIniFile); 

		sprintf(szPar, "%u", g_MyCaptureSet.MyPar3); 
		WritePrivateProfileString("Capture", "MyPar3", szPar, g_szIniFile); 

		sprintf(szPar, "%u", g_MyCaptureSet.MyPar4); 
		WritePrivateProfileString("Capture", "MyPar4", szPar, g_szIniFile); 

	}

}


void AppendDialogParams(HWND hwDlg, BOOL IsCapture)
{
	if (!IsCapture)
	{
		SetDlgItemInt(hwDlg, IDC_PAR1, g_MyPreviewSet.MyPar1, FALSE);
		SetDlgItemInt(hwDlg, IDC_PAR2, g_MyPreviewSet.MyPar2, FALSE);
		SetDlgItemInt(hwDlg, IDC_PAR3, g_MyPreviewSet.MyPar3, FALSE);
		CheckDlgButton(hwDlg, IDC_PAR4, g_MyPreviewSet.MyPar4);
	}
	else
	{
		SetDlgItemInt(hwDlg, IDC_PAR1, g_MyCaptureSet.MyPar1, FALSE);
		SetDlgItemInt(hwDlg, IDC_PAR2, g_MyCaptureSet.MyPar2, FALSE);
		SetDlgItemInt(hwDlg, IDC_PAR3, g_MyCaptureSet.MyPar3, FALSE);
		CheckDlgButton(hwDlg, IDC_PAR4, g_MyCaptureSet.MyPar4);
	}
}

// Callback     
LRESULT CALLBACK DialogProc(HWND hDlgW, UINT message, WPARAM wParam, LPARAM lParam)
{
	
	static BOOL s_IsCaptureMode;

	UDACCEL aAccels[1];

	switch (message)
	{
		case WM_INITDIALOG:			//  
			{
				// ,      
				s_IsCaptureMode = (BOOL) lParam;  

				//   - #1  0-255
				SendMessage(GetDlgItem( hDlgW, IDC_PAR1_SPIN ), UDM_SETRANGE, 0, MAKELPARAM(255, 0)); 

				//   - #2  0-400
				SendMessage(GetDlgItem( hDlgW, IDC_PAR2_SPIN ), UDM_SETRANGE, 0, MAKELPARAM(400, 0));

				//   - #3  0-50
				SendMessage(GetDlgItem( hDlgW, IDC_PAR3_SPIN ), UDM_SETRANGE, 0, MAKELPARAM(50, 0));

				//   - #1 = 5 
				SendMessage(GetDlgItem( hDlgW, IDC_PAR1_SPIN ), UDM_GETACCEL, 1, (LPARAM) (LPUDACCEL) aAccels);
				aAccels[0].nInc = 5;
				SendMessage(GetDlgItem( hDlgW, IDC_PAR1_SPIN ), UDM_SETACCEL, 1, (LPARAM) (LPUDACCEL) aAccels);

				//   - #2 = 10 
				SendMessage(GetDlgItem( hDlgW, IDC_PAR2_SPIN ), UDM_GETACCEL, 1, (LPARAM) (LPUDACCEL) aAccels);
				aAccels[0].nInc = 10;
				SendMessage(GetDlgItem( hDlgW, IDC_PAR2_SPIN ), UDM_SETACCEL, 1, (LPARAM) (LPUDACCEL) aAccels);

				//   - #3 = 2 
				SendMessage(GetDlgItem( hDlgW, IDC_PAR3_SPIN ), UDM_GETACCEL, 1, (LPARAM) (LPUDACCEL) aAccels);
				aAccels[0].nInc = 2;
				SendMessage(GetDlgItem( hDlgW, IDC_PAR3_SPIN ), UDM_SETACCEL, 1, (LPARAM) (LPUDACCEL) aAccels);

				//      
				SetWindowText(hDlgW, szPluginName);

				//   
				AppendDialogParams(hDlgW, s_IsCaptureMode);

				return TRUE;
			}
			break;
		case WM_DESTROY:			//  
			{
				g_hDlg = NULL;

				SavePluginSettings();

				return TRUE;
			}
			break;
		case WM_COMMAND:			//     

			switch LOWORD(wParam)
			{
				case ID_EXIT:		//  ""
					{
						DestroyWindow(hDlgW);

						return TRUE;
					}
					break;

				case ID_APPLY:      //  ""                
					{
						if (!s_IsCaptureMode)
						{
							g_MyPreviewSet.MyPar1 = GetDlgItemInt(hDlgW, IDC_PAR1, NULL, FALSE);
							g_MyPreviewSet.MyPar2 = GetDlgItemInt(hDlgW, IDC_PAR2, NULL, FALSE);
							g_MyPreviewSet.MyPar3 = GetDlgItemInt(hDlgW, IDC_PAR3, NULL, FALSE);
							g_MyPreviewSet.MyPar4 = (IsDlgButtonChecked(hDlgW, IDC_PAR4) == BST_CHECKED);
						}
						else
						{
							g_MyCaptureSet.MyPar1 = GetDlgItemInt(hDlgW, IDC_PAR1, NULL, FALSE);
							g_MyCaptureSet.MyPar2 = GetDlgItemInt(hDlgW, IDC_PAR2, NULL, FALSE);
							g_MyCaptureSet.MyPar3 = GetDlgItemInt(hDlgW, IDC_PAR3, NULL, FALSE);
							g_MyCaptureSet.MyPar4 = (IsDlgButtonChecked(hDlgW, IDC_PAR4) == BST_CHECKED);
						}

						return TRUE;
					}
					break;

				case ID_DEFAULT:    //  " "                
					{
						if (!s_IsCaptureMode)
						{
							g_MyPreviewSet.MyPar1 = DefaultPar1;
							g_MyPreviewSet.MyPar2 = DefaultPar2;
							g_MyPreviewSet.MyPar3 = DefaultPar3;
							g_MyPreviewSet.MyPar4 = DefaultPar4;
						}
						else
						{
							g_MyCaptureSet.MyPar1 = DefaultPar1;
							g_MyCaptureSet.MyPar2 = DefaultPar2;
							g_MyCaptureSet.MyPar3 = DefaultPar3;
							g_MyCaptureSet.MyPar4 = DefaultPar4;
						}

						AppendDialogParams(hDlgW, s_IsCaptureMode);

						return TRUE;
					}
					break;  
        
				default:
					break;

			}
			break;

		default:
			break;
	}
	return FALSE;
}


// ******************   (  API) *********************

////////////////////////////////////////////////////////////////////////////////
// *   *
////////////////////////////////////////////////////////////////////////////////
void __cdecl PP_Init(INIT_STR *pPrInit)
{
	//     


	//        
	if (pPrInit)
	{
		g_PtrByOrd = pPrInit->pChByOrd;
		g_PtrByIdx = pPrInit->pChByIdx;
	}


	//    
	LoadPluginSettings();  
}


////////////////////////////////////////////////////////////////////////////////
// *  StartStreaming *
////////////////////////////////////////////////////////////////////////////////
BOOL __cdecl PP_StartStreaming(PARAM_STR *pPrPar)
{
	//      - 
	//   ,  CPU ( ),
	//  ,      (Capture/Preview),
	// ( ,       ..)

	if (pPrPar)
	{
		g_TypeCPU			= pPrPar->TypeCPU;
		g_IsCaptureMode		= pPrPar->IsCapture;
		g_PixFmt			= pPrPar->PixFmt;
	}

	//..........................................

	return TRUE;
}


////////////////////////////////////////////////////////////////////////////////
// *   *
////////////////////////////////////////////////////////////////////////////////


BOOL __cdecl PP_Inverse_MMX(PROC_STR *pPr)
{

// .        
//    

	const __int64 InvertMask64 = 0xffffffffffffffff;
	const ULONG InvertMask32   = 0xffffffff;
	int x, y, xcycles;

	BYTE* pSrcBuffer  = (BYTE*) pPr->SrcBuff[0];			//        

	if (pSrcBuffer == NULL)									//    								
		return FALSE;

//    ,    , CPU    MMX 
	if (g_TypeCPU != CPU_SIMPLE)
	{
		xcycles = pPr->SrcLength >> 3;						// (pPr->SrcLength / 8)

		for (y = 0; y < pPr->FrameHeight; y++)				//    
		{
			for (x = 0; x < xcycles; x++)					//  1/8   
			{
				__asm
				{
					mov   eax, dword ptr[pSrcBuffer]		//   eax    
					movq  mm0, qword ptr[eax]				//   MMX  mm0    8 
					pxor  mm0, InvertMask64					//    MMX  mm0 
					movq  qword ptr[eax], mm0				//    MMX   8   
					add   pSrcBuffer, 8						//      8 
				}
			}
		}

		__asm
		{
			emms											//     MMX
		}

	}
	else	//    MMX  4   
	{
		xcycles = pPr->SrcLength >> 2;						// (pPr->SrcLength / 4)

		DWORD *pBuffer32;

		for (y = 0; y < pPr->FrameHeight; y++)				//    
		{
			for (x = 0; x < xcycles; x++)					//  1/4   
			{
				pBuffer32 = (DWORD*) pSrcBuffer;			//    32-  (4   )
				*pBuffer32 ^= InvertMask32;					//    32  
				pSrcBuffer += 4;							//      4 
			}
		}

	}


//   ,    :

	char *NameTV;
	TChannelInfo* pInfoTV;

//     
	NameTV = pPr->ChInfo->ChnlName;

//       = 8 
	pInfoTV = g_PtrByOrd(8);

	if (pInfoTV != NULL)
	{
		NameTV = pInfoTV->ChnlName;
	}

//       = 127358376293300000
	pInfoTV = g_PtrByIdx(127358376293300000);

	if (pInfoTV != NULL)
	{
		NameTV = pInfoTV->ChnlName;
	}


	return TRUE;

}



////////////////////////////////////////////////////////////////////////////////
// *  StopStreaming *
////////////////////////////////////////////////////////////////////////////////
void __cdecl PP_StopStreaming(void)
{
	//     
	// (      ..)
}


////////////////////////////////////////////////////////////////////////////////
// *     *
////////////////////////////////////////////////////////////////////////////////
void __cdecl PP_ShowDialog(DLG_STR *pDlgPar)
{

	if(g_hDlg == NULL)
	{
		if (g_szIniFile[0] == 0)
			LoadPluginSettings();

		// pDlgPar->LangCode   ,      

		g_hDlg = CreateDialogParam(g_hInst, (LPCTSTR) IDD_MYDIALOG, pDlgPar->hwndParent, (DLGPROC) DialogProc, (LPARAM) pDlgPar->IsCapture);
		if (g_hDlg)
		{
			//      
			RECT pRect, lRect;			

			GetWindowRect(pDlgPar->hwndParent, &pRect);
			GetWindowRect(g_hDlg, &lRect);

			int lft, top;

			lft = pRect.left + (pRect.right / 2 - lRect.right / 2);		
			top = pRect.top + (pRect.bottom / 2 - lRect.bottom / 2);

			SetWindowPos(g_hDlg, HWND_TOP, lft, top, 0, 0, SWP_NOACTIVATE | SWP_NOSIZE);
			ShowWindow(g_hDlg, SW_SHOW);
		}
    }

}


////////////////////////////////////////////////////////////////////////////////
// *   *
////////////////////////////////////////////////////////////////////////////////
void __cdecl PP_Uninit(void)
{
	//     

	SavePluginSettings();		//    

	if(g_hDlg != NULL)
	{
		DestroyWindow(g_hDlg);  //  
		g_hDlg = NULL;
	}

	g_PtrByOrd = NULL;
	g_PtrByIdx = NULL;
}

////////////////////////////////////////////////////////////////////////////////
// *     *
////////////////////////////////////////////////////////////////////////////////
PROC_PLUGIN Inverse_PL =
{
	szPluginName,				//   (  )
	szPluginDesc,				//  
	PP_Init,					//     (  NULL)
	PP_StartStreaming,			//    StartStreaming (  NULL)
	PP_Inverse_MMX,				//     ()
	PP_StopStreaming,			//    StopStreaming (  NULL)
	PP_ShowDialog,				//       (  NULL)
	PP_Uninit					//     (  NULL)
};


// ********************* Exports ***********************************************

extern "C" {

BH_PLUGIN_EXP ULONG BeholdTV_Plugin_Version()
{
	return DSPLUGINVER;		//    
}

BH_PLUGIN_EXP PROC_PLUGIN* BeholdTV_Plugin_PR()
{
	return &Inverse_PL;		//     
}

}

// ********************* DllMain ************************************************

BOOL APIENTRY DllMain( HINSTANCE hModule, DWORD ul_reason_for_call, LPVOID lpReserved )
{
	switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
			g_hInst = hModule;
			break;
		case DLL_PROCESS_DETACH:
			break;
	}
	return TRUE;
}