unit Common;

interface

{$MINENUMSIZE 4}

uses Windows;

const
  //     DirectShow  (  )
  DSPLUGINVER : ULONG = $0003;

  //   (  )
  CPU_SIMPLE : ULONG = 1;  //  
  CPU_MMX    : ULONG = 2;  //   MMX
  CPU_K7     : ULONG = 3;  // AMD Athlon XP/Duron Morgan or higher (Extended MMX + SSE + prefetch)
  CPU_SSE    : ULONG = 4;  // Intel SSE (Pentium III)
  CPU_SSE2   : ULONG = 5;  // Intel SSE2 (Pentium 4)

type
  //  
  ePixFmt =
  (
    fYUY2 = 0,
    fRGB24
  );

  PARAM_STR = record
    FrameWidth   : Longint;  //  
    FrameHeight  : Longint;  //  
    BitPerPixel  : Longint;  //    (2  16bpp; 3  24bpp ))
    PixFmt       : ePixFmt;  //   (YUY2  RGB24)
    TypeCPU      : ULONG;    //  
    IsCapture    : BOOL;     // , ,         
  end;
  PPARAM_STR = ^PARAM_STR;

  DLG_STR = record
    hwndParent  : HWND;      //   
    IsCapture   : BOOL;      //       
    LangCode    : ULONG;     //   (   )
  end;
  PDLG_STR = ^DLG_STR;

  //     memcpy (MMX, Athlon XP, SSE)
  MCPY_FUNC = procedure(pDst : Pointer; const pSrc : Pointer; nSize : Longint); cdecl;


/////////////////////////////////////////////////////////////////////////////////////////////////////////
// API   
//
//                              
//     Dynamic-Link Library (dll), 
//    BPD_*.dll   :
//
// "BeholdTV_Plugin_Version"
// "BeholdTV_Plugin_DI".
//
//     -    ,  
//  "",  -     
//    . 
//
//         
//   (DstBuffer).    DstBuffer    
//           .
//
//     DirectShow      
//     DINT_PLUGIN_FUNC.     
// .
//
//      DINT_PLUGIN_FUNC      - 50   .
//      2  : 
//  -      Odd   ,  Even    
//  -      Odd  Even    
// 
// ,         , Odd  Even,  
//   Odd Field First (IsOdd).  IsOdd = TRUE: 
// 
//  -------------|-------------------------|-------------------------|-------------
// ... Odd1/Evn1 -> Odd2/Evn1 -> Odd2/Evn2 -> Odd3/Evn2 -> Odd3/Evn3 -> Odd4/Evn3 -> ...
//  -------------|-------------------------|-------------------------|-------------
// 
/////////////////////////////////////////////////////////////////////////////////////////////////////////

  PTR_SRC = array[0..3] of array of PBYTE;

  //  ,       DINT_PLUGIN_FUNC
  //  
  DINT_STR = record
    SrcOdd      : PTR_SRC;    //       (   )
    SrcEven     : PTR_SRC;    //       (   )
                              //    [0] - . [1], [2], [3] -   
    DstBuffer   : PBYTE;      //    
    pMcpy       : MCPY_FUNC;  //     memcpy (MMX, Athlon, SSE) -  
    IsOdd       : BOOL;       //   
    FrameWidth  : Longint;    //   ( )
    FieldHeight : Longint;    //   (  / 2) -  
    SrcLength   : Longint;    //    (  *    / 8) -  
    SrcPitch    : Longint;    //       (2 *   *    / 8) -  
    DstPitch    : Longint;    //        (   *    / 8) -  
    // -=  ,    =-
    IsDoubleFps : BOOL;       // ,        ( 
                              //          )
  end;
  PDINT_STR = ^DINT_STR;

  //      
  DINT_PLUGIN_INIT   = procedure (); cdecl;
  DINT_PLUGIN_START  = function(pDiPar : PPARAM_STR) : BOOL; cdecl;
  DINT_PLUGIN_FUNC   = function(pDi : PDINT_STR) : BOOL; cdecl;   //    
  DINT_PLUGIN_STOP   = procedure(); cdecl;
  DINT_PLUGIN_DIALOG = procedure(pDlgPar : PDLG_STR); cdecl;
  DINT_PLUGIN_UNINIT = procedure(); cdecl;

  
  //  ,     
  DINT_PLUGIN = record
    szName        : PChar;               //   ()
    szDesc        : PChar;               //   (  Nil)
    pPluginInit   : DINT_PLUGIN_INIT;    //       (   )
    pPluginStart  : DINT_PLUGIN_START;   //    StartStreaming  (   )
    pPluginDeint  : DINT_PLUGIN_FUNC;    //     (     Deliver )
    pPluginStop   : DINT_PLUGIN_STOP;    //    StopStreaming   (   )
    pPluginDialog : DINT_PLUGIN_DIALOG;  //       
    pPluginUninit : DINT_PLUGIN_UNINIT;  //     (   )
  end;
  PDINT_PLUGIN = ^DINT_PLUGIN;

  //     c  "BeholdTV_Plugin_Version"
  BEHOLDTVPLUGINVERSION = function () : ULONG; cdecl;

  //     c  "BeholdTV_Plugin_DI"
  BEHOLDTVPLUGINDI      = function () : PDINT_PLUGIN; cdecl;

  

/////////////////////////////////////////////////////////////////////////////////////////////////////////
// API   
//
//                              
//     Dynamic-Link Library (dll), 
//    BPP_*.dll   :
//
// "BeholdTV_Plugin_Version"
// "BeholdTV_Plugin_PR"
//
//     -      
//  .
//
//         (SrcBuff).
//
//     DirectShow      
//     PROC_PLUGIN_FUNC.     
// .
/////////////////////////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////////////////////////////
//  
/////////////////////////////////////////////////////////////////////////////////////////////////////////

  // 
  eVStd =
  (
    VSTD_AUTODETECT = 0,   // Automatic detection
    VSTD_SECAM,            // 50Hz, SECAM
    VSTD_PAL,              // 50Hz, PAL BGDHI
    VSTD_PAL_60,           // 60Hz, PAL 60
    VSTD_NTSC_M,           // 60Hz, NTSC M
    VSTD_NTSC_Japan        // 60Hz, NTSC-Japan
  );

  // 
  eAStd =
  (
    ASTD_0 = 0,
    ASTD_1,
    ASTD_2,
    ASTD_3,
    ASTD_4,
    ASTD_5,
    ASTD_6,
    ASTD_7,
    ASTD_8,
    ASTD_9,
    ASTD_10,
    ASTD_11,
    ASTD_12,
    ASTD_13,
    ASTD_14,
    ASTD_15
  );

  //     
  TChannelInfo = record
    ChnlIdx      : int64;                //     (   = -1,  CompositeIn = 1,  S-VideoIn = 2)
    ChnlOrder    : Longint;              //     (   = -1,  CompositeIn = -2,  S-VideoIn = -3)
    ChnlName     : array[0..63] of Char; //    ( CompositeIn = "Composite",  S-VideoIn = "S-Video")
    Frequency    : Longint;              //   ( 49.75 = 49750000.  CompositeIn/S-VideoIn = 0)

    VideoStd     : eVStd;                // 
    AudioStd     : eAStd;                // 

    Brightness   : Longint;              // 
    Contrast     : Longint;              // 
    Saturation   : Longint;              // 
    Hue          : Longint;              // 
    Sharpness    : Longint;              // 
    Gain         : Longint;              //  

    AudioVolume  : Longint;              // 
    AudioBalance : Longint;              // 

    Zoom         : Longint;              //    %
    LeftOffSet   : Longint;              //      %
    TopOffSet    : Longint;              //      %
  end;
  PChannelInfo = ^TChannelInfo;


  //        
  BY_ORD_FUNC = function (ChOrder : Longint) : PChannelInfo; cdecl;

  //        
  BY_IDX_FUNC = function (ChIdx : int64) : PChannelInfo; cdecl;


/////////////////////////////////////////////////////////////////////////////////////////////////////////

  //  ,       PROC_PLUGIN_INIT
  INIT_STR = record
    pChByOrd : BY_ORD_FUNC; //   ,           (   ,  NULL)
    pChByIdx : BY_IDX_FUNC; //   ,            (   ,  NULL)
  end;
  PINIT_STR = ^INIT_STR;


  //  ,       PROC_PLUGIN_FUNC
  PROC_STR = record
    SrcBuff       : array [0..3] of PBYTE; //     (   ).
                                           //    [0] - . [1], [2], [3] -   
    pMcpy         : MCPY_FUNC;             //     memcpy (MMX, AthlonXP, SSE) -  
    FrameWidth    : Longint;               //   ( )
    FrameHeight   : Longint;               //   ( )
    SrcLength     : Longint;               //    (  *    / 8) -  
    SrcPitch      : Longint;               //       (  *    / 8) -  
    // -=  ,    =-
    IsHSync       : BOOL;                  // , ,       (. )
    IsChnlChanged : BOOL;                  // ,      (  )
    ChInfo        : PChannelInfo;          //      (   CompositeIn/S-VideoIn)
  end;
  PPROC_STR = ^PROC_STR;

  //      
  PROC_PLUGIN_INIT   = procedure(pPrInit : PINIT_STR); cdecl;
  PROC_PLUGIN_START  = function(pPrPar : PPARAM_STR) : BOOL; cdecl;
  PROC_PLUGIN_FUNC   = function(pPr : PPROC_STR) : BOOL; cdecl;   //    
  PROC_PLUGIN_STOP   = procedure(); cdecl;
  PROC_PLUGIN_DIALOG = procedure(pDlgPar : PDLG_STR); cdecl;
  PROC_PLUGIN_UNINIT = procedure(); cdecl;

  //  ,     
  PROC_PLUGIN = record
    szName        : PChar;               //   ()
    szDesc        : PChar;               //   (  Nil)
    pPluginInit   : PROC_PLUGIN_INIT;    //     (   )
    pPluginStart  : PROC_PLUGIN_START;   //    StartStreaming (   )
    pPluginProc   : PROC_PLUGIN_FUNC;    //     (     Deliver )
    pPluginStop   : PROC_PLUGIN_STOP;    //    StopStreaming (   )
    pPluginDialog : PROC_PLUGIN_DIALOG;  //       
    pPluginUninit : PROC_PLUGIN_UNINIT;  //     (   )
  end;
  PPROC_PLUGIN = ^PROC_PLUGIN;


//     c  "BeholdTV_Plugin_PR"
  BEHOLDTVPLUGINPR      = function () : PPROC_PLUGIN; cdecl;


implementation



end.
