unit Deinterlace;

interface

{$MINENUMSIZE 4}

uses Windows, Common, IniFiles;

const
  szPluginName = 'Duplication fields deinterlace';
  szPluginDesc = '  ';

type
  TSettings = record
    MyPar1 : Integer;
    MyPar2 : Boolean;
  end;

var
  g_hParent   : HWND = 0;
  g_Settings  : TSettings;

  function BeholdTV_Plugin_Version() : ULONG; cdecl;
  function BeholdTV_Plugin_DI() : PDINT_PLUGIN; cdecl;

  procedure PD_Init(); cdecl;
  function  PD_StartStreaming(pDiPar : PPARAM_STR) : BOOL; cdecl;
  function  PD_Douple(pDi : PDINT_STR): BOOL; cdecl;
  procedure PD_StopStreaming(); cdecl;
  procedure PD_ShowDialog(pDlgPar : PDLG_STR); cdecl;
  procedure PD_Uninit(); cdecl;

  procedure GetIniFileName();
  procedure LoadPluginSettings();
  procedure SavePluginSettings();

implementation

uses
  Controls, MyDialog;

var
  ConfigForm     : TConfigForm = Nil;
  g_DouplePlugin : DINT_PLUGIN;     //    
  g_szIniFile    : String = '';
  g_nFrameWidth  : Longint;
  g_nFrameHeight : Longint;
  g_nBitPerPixel : Longint;
  g_PixFmt       : ePixFmt;
  g_ulTypeCPU    : ULONG;
  g_AlreadyLoad  : Boolean = False;


  
// ****************   () **************************

//       ,    
procedure GetIniFileName();
Var
  szPathFull : array[0..MAX_PATH - 1] of Char;
  szPathIni  : array[0..MAX_PATH - 1] of Char;
  pszFile    : PChar;
  szPath     : String;
Begin
  if (g_szIniFile <> '') then Exit;

  if ( GetModuleFileName(HInstance, szPathFull, sizeof(szPathFull)) <> 0) then begin
    if (GetFullPathName(szPathFull, sizeof(szPathIni), szPathIni, pszFile) <> 0) then begin
      szPath := String(szPathIni);
      g_szIniFile := Copy(szPath, 1, Length(szPath) - 4) + '.ini';
    end;
  end;
  
End;


procedure LoadPluginSettings();
Var
  MyIni : TIniFile;
Begin
  if (g_AlreadyLoad) then Exit;
  
  GetIniFileName();

  //       Preview  Capture ( )
  if (g_szIniFile <> '') then begin
    MyIni := TIniFile.Create(g_szIniFile);
    try
      g_Settings.MyPar1 := MyIni.ReadInteger ('Common', 'MyPar1', 640);
      g_Settings.MyPar2 := MyIni.ReadBool ('Common', 'MyPar2', True);

      g_AlreadyLoad := True;
    finally
      MyIni.Free();
    end;
  end;

  // :
  //   VCL  TIniFile,  dll   ~80 
  //      TIniFile,  WinAPI  
  // ini  "GetPrivateProfileInt"  "GetPrivateProfileString"

End;

procedure SavePluginSettings();
Var
  MyIni : TIniFile;
Begin
  GetIniFileName();

  //       Preview  Capture ( )
  if (g_szIniFile <> '') then begin
    MyIni := TIniFile.Create(g_szIniFile);
    try
      MyIni.WriteInteger ('Common', 'MyPar1', g_Settings.MyPar1);
      MyIni.WriteBool ('Common', 'MyPar2', g_Settings.MyPar2);
    finally
      MyIni.Free();
    end;
  end;

  // :
  //   VCL  TIniFile,  dll   ~80 
  //      TIniFile,  WinAPI  
  //  ini  "WritePrivateProfileString"

End;

// ******************   (  API) *********************

////////////////////////////////////////////////////////////////////////////////
// *   *
////////////////////////////////////////////////////////////////////////////////
procedure PD_Init();
Begin
 //     

  LoadPluginSettings();  //    

End;

////////////////////////////////////////////////////////////////////////////////
// *  StartStreaming *
////////////////////////////////////////////////////////////////////////////////
function PD_StartStreaming(pDiPar : PPARAM_STR) : BOOL;
Begin
 //     
 //   ,  CPU ( )
 // ( ,       ..)

  if (pDiPar <> Nil) then begin
    g_nFrameWidth  := pDiPar^.FrameWidth;
    g_nFrameHeight := pDiPar^.FrameHeight;
    g_nBitPerPixel := pDiPar^.BitPerPixel;
    g_PixFmt      := pDiPar^.PixFmt;
    g_ulTypeCPU    := pDiPar^.TypeCPU;
  end;

 //..........................................

  Result := TRUE;
End;


////////////////////////////////////////////////////////////////////////////////
// *   *
////////////////////////////////////////////////////////////////////////////////
function PD_Douple(pDi : PDINT_STR): BOOL;
Var
  i : Longint;
  pSrcBuffer : PBYTE;
  pDstBuffer : PBYTE;
Begin
 // .       
 //    

  Result := FALSE;

  pDstBuffer := pDi^.DstBuffer;           //     

  if (pDi^.IsOdd) then begin              // ,    

    pSrcBuffer := pDi^.SrcOdd[0, 0];      //           
    if (pSrcBuffer = Nil) then            //    
      Exit;

    pDi^.pMcpy(pDstBuffer, pSrcBuffer, pDi^.SrcLength);   //      
    inc(pDstBuffer, pDi^.DstPitch);                       //  ,   
                                                          //   
    for i := 0 to pDi^.FieldHeight - 2 do begin
    //        
      pDi^.pMcpy(pDstBuffer, pSrcBuffer, pDi^.SrcLength);
      inc(pDstBuffer, pDi^.DstPitch);                     //       

      pDi^.pMcpy(pDstBuffer, pSrcBuffer, pDi^.SrcLength);
      inc(pSrcBuffer, pDi^.SrcPitch);                     //        
      inc(pDstBuffer, pDi^.DstPitch);                     //       
    end;

    pDi^.pMcpy(pDstBuffer, pSrcBuffer, pDi^.SrcLength);

  end
    else begin

      pSrcBuffer := pDi^.SrcEven[0, 0];                   //           
      if (pSrcBuffer = Nil) then                          //    
        Exit;

      for i := 0 to pDi^.FieldHeight - 1 do begin
        //        
        pDi^.pMcpy(pDstBuffer, pSrcBuffer, pDi^.SrcLength);
        inc(pDstBuffer, pDi^.DstPitch);                   //       

        pDi^.pMcpy(pDstBuffer, pSrcBuffer, pDi^.SrcLength);
        inc(pSrcBuffer, pDi^.SrcPitch);                   //        
        inc(pDstBuffer, pDi^.DstPitch);                   //       
      end;

    end;

  // :
  //       ,  
  //      ,   IsOdd  
  // .      
  //     

  Result := TRUE;
End;


////////////////////////////////////////////////////////////////////////////////
// *  StopStreaming *
////////////////////////////////////////////////////////////////////////////////
procedure PD_StopStreaming();
Begin
 //     
 // (      ..)


End;


////////////////////////////////////////////////////////////////////////////////
// *     *
////////////////////////////////////////////////////////////////////////////////
procedure PD_ShowDialog(pDlgPar : PDLG_STR);
Begin
  g_hParent := pDlgPar^.hwndParent;

  LoadPluginSettings();  //   

  if (ConfigForm = nil) then
    ConfigForm := TConfigForm.Create(Nil);

  ConfigForm.Show();

  // :
  //   VCL  TForm,  dll   ~350 
  //      TForm,  WinAPI  
  //  "CreateDialog", "DialogBox",       .
  
End;


////////////////////////////////////////////////////////////////////////////////
// *   *
////////////////////////////////////////////////////////////////////////////////
procedure PD_Uninit();
Begin
 //     

  SavePluginSettings();  //    

  if (ConfigForm <> nil) then begin
    ConfigForm.Close();
    ConfigForm.Free();
    ConfigForm := Nil;    
  end;


End;


// ********************* Exports ***********************************************

function BeholdTV_Plugin_Version() : ULONG;
Begin
  Result := DSPLUGINVER;
End;

function BeholdTV_Plugin_DI() : PDINT_PLUGIN;
Begin
  g_DouplePlugin.szName        := PChar(szPluginName);
  g_DouplePlugin.szDesc        := PChar(szPluginDesc);
  g_DouplePlugin.pPluginInit   := PD_Init;            //     (  Nil)
  g_DouplePlugin.pPluginStart  := PD_StartStreaming;  //    StartStreaming (  Nil)
  g_DouplePlugin.pPluginDeint  := PD_Douple;          //     ()
  g_DouplePlugin.pPluginStop   := PD_StopStreaming;   //    StopStreaming (  Nil)
  g_DouplePlugin.pPluginDialog := PD_ShowDialog;      //       (  Nil)
  g_DouplePlugin.pPluginUninit := PD_Uninit;          //     (  Nil)

  Result := @g_DouplePlugin;
End;

end.
